package org.foxarmy.barcodescannerforemployees

import android.os.Parcel
import android.os.Parcelable

class AbstractProduct() : Parcelable {
    var id: Int = 0
    var name: String = ""
    var netWeight: Double = 0.0
    var imageHash: String = ""
    var category: Int = 0

    constructor(id: Int, name: String ,netWeight: Double, imageHash: String, category: Int) : this() {
        this.id = id
        this.name = name
        this.netWeight = netWeight
        this.imageHash = imageHash
        this.category= category
    }

    constructor(parcel: Parcel) : this() {
        id = parcel.readInt()
        name = parcel.readString()!!
        netWeight = parcel.readDouble()
        imageHash = parcel.readString()!!
        category = parcel.readInt()
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(id)
        parcel.writeString(name)
        parcel.writeDouble(netWeight)
        parcel.writeString(imageHash)
        parcel.writeInt(category)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<AbstractProduct> {
        override fun createFromParcel(parcel: Parcel): AbstractProduct {
            return AbstractProduct(parcel)
        }

        override fun newArray(size: Int): Array<AbstractProduct?> {
            return arrayOfNulls(size)
        }
    }

}