package org.foxarmy.barcodescannerforemployees

import android.app.Activity
import android.content.Context
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.net.Uri
import android.os.Build
import androidx.annotation.RequiresApi
import androidx.core.content.FileProvider
import androidx.core.graphics.scale
import com.google.firebase.components.BuildConfig
import java.io.File
import java.io.FileOutputStream
import java.security.MessageDigest

fun getImageUri(activity: Activity, imageFile: File): Uri? {
    return FileProvider.getUriForFile(activity, BuildConfig.APPLICATION_ID + "." + activity.localClassName + ".provider", imageFile)
}

@RequiresApi(Build.VERSION_CODES.R)
fun generateThumbnailForImage(context: Context, imageHash: String) {
    val thumbnailsDir = File(context.cacheDir, "thumbnails")
    thumbnailsDir.mkdirs()
    val picturesDir = File(context.filesDir, "pictures")
    picturesDir.mkdirs()
    val thumbnailFile = File(thumbnailsDir, "$imageHash.webp")
    if (thumbnailFile.exists()) return

    val imageFile = File(picturesDir, "$imageHash.png")
    val imageContent = imageFile.inputStream().readBytes()
    var img = BitmapFactory.decodeByteArray(imageContent, 0, imageContent.size)
    img = img.scale(img.width/4,img.height/4)
    img.compress(Bitmap.CompressFormat.WEBP_LOSSY, 25, FileOutputStream(thumbnailFile))
}

@OptIn(ExperimentalStdlibApi::class)
fun String.md5(): String {
    val md = MessageDigest.getInstance("MD5")
    val digest = md.digest(this.toByteArray())
    return digest.toHexString()
}